<?php

class ilPlagScanDocumentManagement
{
    public static function getDocumentStatus($user_id, $assignment_id)
    {
        global $ilDB;
        $result = $ilDB->query('SELECT * FROM psx_submissions WHERE assignment_id = ' . $ilDB->quote($assignment_id, 'integer')
        . ' AND user_id = ' . $ilDB->quote($user_id, 'integer'));
        if($ilDB->numRows($result) == 0)
        {
            return 'no_submission';
        } else {
            $row = $ilDB->fetchAssoc($result);
            return $row['plagscan_status'] ? $row['plagscan_status'] : 'not_checked';
        }
    }

    public static function handInDocumentAsText($user_id, $assignment_id, $text)
    {

        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocument.php';
        $document = new ilPlagScanDocument();
        $document->getByUserAssignment($user_id, $assignment_id);
        $settings = new ilSetting('psx');
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/PlagScan/Helper/Documents.php';
        $documents = new \PlagScanApi\Documents($settings->get('psx_server', 'https://api.plagscan.com/'));

        if($document->getId() != null)
        {
            $documents->delete($document->getPlagscanId());
            $document->setPlagscanId(null);
            $document->setShareLink('');
        }

        $response = $documents->add($text, true);
        $document->setPlagscanId($response['docID']);
        $document->setPlagscanStatus('not_checked');
        $document->setAssignmentExcObj(ilObject::_lookupObjectId((int)$_GET['ref_id']));
        $document->setUserNonConsent(false);
        $document->setSubmissionIliasId(0);
        $document->setShareLink('');
        $document->store();
    }
    public static function handInDocumentAsFile($user_id, $assignment_id)
    {
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocument.php';
        $document = new ilPlagScanDocument();
        $document->getByUserAssignment($user_id, $assignment_id);
        $settings = new ilSetting('psx');
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/PlagScan/Helper/Documents.php';
        $documents = new \PlagScanApi\Documents($settings->get('psx_server', 'https://api.plagscan.com/'));

        if($document->getId() != null)
        {
            $documents->delete($document->getPlagscanId());
            $document->setPlagscanId(null);
            $document->setShareLink('');
        }
        $ex_submission = new ilExSubmission(new ilExAssignment($assignment_id),$user_id);
        $files = $ex_submission->getFiles();
        $file_info = end($files);
        $response = $documents->add($file_info['filename'], false);
        $document->setPlagscanId($response['docID']);
        $document->setPlagscanStatus('not_checked');
        $document->setAssignmentExcObj(ilObject::_lookupObjectId((int)$_GET['ref_id']));
        $document->setUserNonConsent(false);
        $document->setSubmissionIliasId(0);
        $document->setShareLink('');
        $document->store();
    }

    public static function checkAllDocuments()
    {
        global $ilDB;
        $result = $ilDB->query('SELECT * FROM psx_submissions WHERE plagscan_status = ' . $ilDB->quote('not_checked', 'text'));

        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
        require_once './Modules/Exercise/classes/class.ilExAssignment.php';
        $psx_assignment_persistence = new ilPlagScanAssignmentConfigPersistence($ilDB);

        while($row = $ilDB->fetchAssoc($result))
        {
            $psx_assignment = $psx_assignment_persistence->getByAssignmentId($row['assignment_id']);
            $assignment = new ilExAssignment($row['assignment_id']);
            if($assignment->afterDeadline() && $psx_assignment->getStartCheck() == 'automatic' && $row['plagscan_id'] != '')
            {
                self::checkDocument($row['plagscan_id']);
            }
        }
    }

    public static function updateAllDocuments()
    {
        global $ilDB;
        $result = $ilDB->query('SELECT * FROM psx_submissions WHERE plagscan_status = ' . $ilDB->quote('in_progress', 'text'));

        while($row = $ilDB->fetchAssoc($result))
        {
            self::updateDocumentStatus($row['plagscan_id']);
        }
    }

    public static function checkDocument($document_id)
    {
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocument.php';
        $document = new ilPlagScanDocument();
        $document->getByPlagScanId($document_id);
        if ($document->getPlagscanStatus() == 'not_checked') {
            $settings = new ilSetting('psx');
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/PlagScan/Helper/Documents.php';
            $documents = new \PlagScanApi\Documents($settings->get('psx_server', 'https://api.plagscan.com/'));
            $documents->check($document_id);
            $document->setPlagscanStatus('in_progress');
            $document->store();
        }
    }

    public static function updateDocumentStatus($document_íd)
    {
        require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocument.php';
        $document = new ilPlagScanDocument();
        $document->getByPlagScanId($document_íd);
        if ($document->getPlagscanStatus() == 'in_progress') {
            $settings = new ilSetting('psx');
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/PlagScan/Helper/Documents.php';
            $documents = new \PlagScanApi\Documents($settings->get('psx_server', 'https://api.plagscan.com/'));
            $document_status = $documents->getStatus($document_íd);
            if($document_status['state'] == 3) {
                $documents->share($document_íd);
                $document_link = $documents->getShareLink($document_íd);
                $document_report = $documents->retrieveReport($document_íd, 4);
                $document->setPlagscanStatus('plagLevel_'.$document_report['plagLevel']);
                $document->setShareLink($document_link['shareLink']);
                $document->store();
            }
        }
    }
}