<?php
/**
 * @category PlagScanExercise
 * @package PlagScan
 * @author Maximilian Becker <mbecker@databay.de>
 * @copyright 2019 Maximilian Becker / Databay AG
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link http://www.databay.de Databay AG
 */

// @codingStandardsIgnoreStart
require_once './Services/UIComponent/classes/class.ilUIHookPluginGUI.php';
// @codingStandardsIgnoreEnd

/**
 * Class ilPlagScanExerciseUIHookGUI
 */
class ilPlagScanExerciseUIHookGUI extends ilUIHookPluginGUI
{
    protected static $assignment_counter = 0;
    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * (Derived method)
     *
     * @param string $a_comp Component
     * @param string $a_part Part
     * @param array  $a_par  Parameter
     *
     * @return array
     */
    public function getHTML($a_comp, $a_part, $a_par = array())
    {
        /** @var ilCtrl $ilCtrl */
        $ilCtrl = $GLOBALS['DIC']->ctrl();
        /** @var ilTemplate $tpl */
        $tpl = $a_par['tpl_obj'];

        // Catch Creation Screen
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == '__global__'
            && $tpl->tplName == 'tpl.form.html'
            && $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && isset($_POST['cmd']['addAssignment'])
            && isset($_POST['type'])
            && ($_POST['type'] == "5" || $_POST['type'] == "1")
            && $GLOBALS['PLX_IN_EXEC'] == false)
        {
            $GLOBALS['PLX_IN_EXEC'] = true;
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExAssignmentEditorGUIOverride.php';
            $override_editor = new ilExAssignmentEditorGUIOverride(ilObject::_lookupObjectId((integer)$_GET['ref_id']), false);
            $override_editor->parent = new ilExAssignmentEditorGUI(ilObject::_lookupObjectId((integer)$_GET['ref_id']), false);
            if($_POST['type'] == "5") {
                $form_html = $override_editor->getTextAssignmentCreationForm()->getHtml();
            } else {
                $form_html = $override_editor->getUploadAssignmentCreationForm()->getHtml();
            }
            $GLOBALS['PLX_IN_EXEC'] = false;
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $form_html );
        }

        // Catch Creation Submit
        if(
            $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && $ilCtrl->getCmd() == 'saveAssignment'
            && $a_comp == 'Services/Utilities'
            && $a_part == 'redirect'
            && $GLOBALS['PLX_CREATION_DONE'] != true
        )
        {
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigData.php';
            $GLOBALS['PLX_CREATION_DONE'] = true;
            $config = new ilPlagScanAssignmentConfigData(
                ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id'])),
              $this->getLatestAssignmentIdForExercise(ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id']))),
              ilUtil::stripSlashes($_POST['psx_activation']) == 1 ? true : false,
              isset($_POST['psx_checkstart']) ? ilUtil::stripSlashes($_POST['psx_checkstart']) : 'none',
                isset($_POST['psx_resultshare']) ?ilUtil::stripSlashes($_POST['psx_resultshare']) : 'none',
              isset($_POST['psx_resulttype']) ?ilUtil::stripSlashes($_POST['psx_resulttype']) : 'none'
            );

            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
            $persistence = new ilPlagScanAssignmentConfigPersistence($GLOBALS['DIC']->database());
            $persistence->store($config);

            // Here we extract the assignment-settings for the assignment and
            return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
        }

        // Catch Edit Assignment Screen
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == '__global__'
            && $tpl->tplName == 'tpl.form.html'
            && $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && $ilCtrl->getCmd('editAssignment')
            && $GLOBALS['PLX_IN_EXECass'] == false)
        {
            $GLOBALS['PLX_IN_EXECass'] = true;
            $assignment = new ilExAssignment((integer)$_GET['ass_id']);
            if($assignment->getAssignmentType() instanceof ilExAssTypeText) {
                require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExAssignmentEditorGUIOverride.php';
                $override_editor = new ilExAssignmentEditorGUIOverride(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $override_editor->parent = new ilExAssignmentEditorGUI(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $form_html = $override_editor->getTextAssignmentUpdateForm()->getHtml();
                $GLOBALS['PLX_IN_EXEC'] = false;
                return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $form_html);
            } else if($assignment->getAssignmentType() instanceof ilExAssTypeUpload) {
                require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExAssignmentEditorGUIOverride.php';
                $override_editor = new ilExAssignmentEditorGUIOverride(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $override_editor->parent = new ilExAssignmentEditorGUI(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $form_html = $override_editor->getUploadAssignmentUpdateForm()->getHtml();
                $GLOBALS['PLX_IN_EXEC'] = false;
                return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $form_html);
            } else {
                return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
            }
        }

        // Catch Edit Assignment Submit Screen
        if(
            $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && $ilCtrl->getCmd() == 'updateAssignment'
            && $a_comp == 'Services/Utilities'
            && $a_part == 'redirect'
        )
        {
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigData.php';

            $config = new ilPlagScanAssignmentConfigData(
                ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id'])),
                ilUtil::stripSlashes($_GET['ass_id']),
                ilUtil::stripSlashes($_POST['psx_activation']) == 1 ? true : false,
                isset($_POST['psx_checkstart']) ? ilUtil::stripSlashes($_POST['psx_checkstart']) : 'none',
                isset($_POST['psx_resultshare']) ?ilUtil::stripSlashes($_POST['psx_resultshare']) : 'none',
                isset($_POST['psx_resulttype']) ?ilUtil::stripSlashes($_POST['psx_resulttype']) : 'none'
            );

            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
            $persistence = new ilPlagScanAssignmentConfigPersistence($GLOBALS['DIC']->database());
            $persistence->store($config);

            return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
        }

        // Catch Submission and Grading Screen / Assignment
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == 'tbl_table_end'
            && $ilCtrl->getCmdClass() == 'ilexercisemanagementgui'
            && ($ilCtrl->getCmd() == 'members' || $ilCtrl->getCmd() == 'selectAssignment')
            && $GLOBALS['PLX_IN_EXEC2'] == false
        )
        {
            $GLOBALS['PLX_IN_EXEC2'] = true;
            if(isset($_GET['chkdoc']))
            {
                $docId = (int) $_GET['chkdoc'];
                require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocumentManagement.php';
                ilPlagScanDocumentManagement::checkDocument($docId);
            }
            $exerciseobj = new ilObjExercise((int)$_GET['ref_id']);
            $assignment = new ilExAssignment((int)$_GET['ass_id']);
            $ex_management = new ilExerciseManagementGUI($exerciseobj,$assignment);
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/table/class.ilExerciseSubmissionTableGUIOverride.php';
            $table = new ilExerciseSubmissionTableGUIOverride(
                $ex_management,
                ilUtil::stripSlashes($_GET['cmd']),
                $exerciseobj,
                (int)$_GET['ass_id']);
            $html = $table->getHTML();
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $html);
        }

        // Catch Submission and Grading Screen / Participant
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == 'tbl_table_end'
            && $ilCtrl->getCmdClass() == 'ilexercisemanagementgui'
            && $ilCtrl->getCmd() == 'showParticipant'
            && $GLOBALS['PLX_IN_EXEC4'] == false
        )
        {
            $GLOBALS['PLX_IN_EXEC4'] = true;
            if(isset($_GET['chkdoc']))
            {
                $docId = (int) $_GET['chkdoc'];
                require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocumentManagement.php';
                ilPlagScanDocumentManagement::checkDocument($docId);
            }
            $exerciseobj = new ilObjExercise((int)$_GET['ref_id']);
            $assignment = new ilExAssignment((int)$_GET['ass_id']);
            $ex_management = new ilExerciseManagementGUI($exerciseobj,$assignment);
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/table/class.ilExParticipantTableGUIOverride.php';
            $table = new ilExParticipantTableGUIOverride(
                $ex_management,
                ilUtil::stripSlashes($_GET['cmd']),
                $exerciseobj,
                2);
            $html = $table->getHTML();
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $html);
        }


        // Catch Assignment Overview (to inject eventual plagscan disclosure)
        if(
            $a_part == 'template_get'
            && $a_par['tpl_id'] == 'Modules/Exercise/tpl.assignment_body.html'
            && $ilCtrl->getCmdClass() == 'ilobjexercisegui'
            && $ilCtrl->getCmd() == 'showOverview'
        )
        {
            //worked on assignment id is in
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExOverviewAdditions.php';
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
            $assignment_persistence = new ilPlagScanAssignmentConfigPersistence($GLOBALS['DIC']->database());
            $assignment = $assignment_persistence->getByAssignmentOrderInRef((int)$_GET['ref_id'],self::$assignment_counter);
            self::$assignment_counter++;
            if($assignment->getActivation() == true) {
                $additions = new ilExOverviewAdditions();
                $form = $additions->getForm($assignment);
                $a_par['html'] = $a_par['html']
                    . '<div class="ilExcAssignmentBody" style="padding-top: -10px; margin-top: -10px;">' . $form->getHTML() . '</div>';
            }
            // Do stuff to $a_par['html']
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $a_par['html']);
        }

        // Catch Working Screen (to inject eventual refusal option)
        if(
            $a_part == 'template_get'
            && $a_par['tpl_id'] == 'Services/Form/tpl.property_form.html'
            && $ilCtrl->getCmdClass() == 'ilexsubmissiontextgui'
            && $ilCtrl->getCmd() == 'editAssignmentText'
        )
        {
            //worked on assignment id is in $_GET
            // Do stuff to $a_par['html']
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $a_par['html']);
        }


        // Catch Submission Submit to process submission and get eventual refusal option choice
        if(
        ($ilCtrl->getCmdClass() == 'ilexsubmissiontextgui' ||$ilCtrl->getCmdClass() == 'ilexsubmissionfilegui')
            && ($ilCtrl->getCmd() == 'updateAssignmentText' || $ilCtrl->getCmd() == 'updateAssignmentTextAndReturn' ||
            $ilCtrl->getCmd() == 'updateAssignmentFile' || $ilCtrl->getCmd() == 'uploadFile')
            && $a_comp == 'Services/Utilities'
            && $a_part == 'redirect'
            && $GLOBALS['PLX_IN_EXEC'] == false
        )
        {
            $GLOBALS['PLX_IN_EXEC'] = true;
            //$_GET['ass_id'], $_GET['ref_id']
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
            $assignment_persistence = new ilPlagScanAssignmentConfigPersistence($GLOBALS['DIC']->database());
            $assignment = $assignment_persistence->getByAssignmentId((int)$_GET['ass_id']);
            if($assignment->getActivation() == true)
            {
                global $ilUser;
                if($ilCtrl->getCmd() == 'updateAssignmentFile' || $ilCtrl->getCmd() == 'uploadFile')
                {
                    require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocumentManagement.php';
                    ilPlagScanDocumentManagement::handInDocumentAsFile($ilUser->getId(), (int) $_GET['ass_id']);
                } else {
                    require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanDocumentManagement.php';
                    ilPlagScanDocumentManagement::handInDocumentAsText($ilUser->getId(), (int) $_GET['ass_id'],
                        ilUtil::stripSlashes($_POST['atxt']));
                }
            }
            // Here we extract the eventual refusal-choice for the submission and
        }
        $GLOBALS['PLX_IN_EXEC'] = false;
        return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * (Derived method)
     *
     * @param string $a_comp Component
     * @param string $a_part Part
     * @param array  $a_par  Parameter
     *
     * @return void
     */
    public function modifyGUI($a_comp, $a_part, $a_par = array())
    {
        $a = 1;
        // None.
    }

    protected function getLatestAssignmentIdForExercise(int $object_id)
    {
        /** @var ilDBPdo $ilDB */
        $ilDB = $GLOBALS['DIC']->database();
        $result = $ilDB->query('SELECT max(id) as maxId FROM exc_assignment WHERE exc_id = '
            . $ilDB->quote($object_id, 'integer'));
        $row = $ilDB->fetchAssoc($result);
        return $row['maxId'];
    }
}
